SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'HernanWilkinson 4/29/2013 20:40'!
blueGhost

	^Ghost blue! !

!PacManTest methodsFor: 'actors' stamp: 'HernanWilkinson 4/29/2013 21:04'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 21:00'!
down

	^ 0 @ -1! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 4/29/2013 21:02'!
ghostHouseDoorType

	^GhostHouseDoorType new! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 20:58'!
left

	^ -1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'achavez 4/29/2013 21:30'!
leftTransporterType

	^LeftTransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'HernanWilkinson 4/29/2013 21:01'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 21:00'!
right

	^1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 4/29/2013 21:01'!
spaceType

	^SpaceType new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 21:00'!
up

	^0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 4/29/2013 20:43'!
wallType

	^WallType new! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'accessing' stamp: 'achavez 5/2/2013 19:13'!
nextPositionWhenMovingInto: aGhostHouseDoorType going: aDirection 

	^aGhostHouseDoorType moveFruit: self going: aDirection! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 20:40'!
blue
	
	^self new! !

!Ghost methodsFor: 'accessing' stamp: 'achavez 5/2/2013 19:13'!
nextPositionWhenMovingInto: aGhostHouseDoorType going: aDirection 

	^aGhostHouseDoorType moveGhost: self going: aDirection! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'accessing' stamp: 'achavez 5/2/2013 19:13'!
nextPositionWhenMovingInto: aGhostHouseDoorType going: aDirection 

	^aGhostHouseDoorType movePacman: self going: aDirection! !

Object subclass: #ConstructionBlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ConstructionBlockType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
moveFruit: aFruit going: aDirection 

	^self subclassResponsibility ! !

!ConstructionBlockType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:21'!
moveGhost: aGhost going: aDirection

	^self subclassResponsibility ! !

!ConstructionBlockType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
movePacman: aPacman going: aDirection
 
	^self subclassResponsibility ! !

!ConstructionBlockType methodsFor: 'accessing' stamp: 'achavez 5/2/2013 19:21'!
nextPositionFor: anActor going: aDirection 

	^anActor nextPositionWhenMovingInto: self going: aDirection.! !

ConstructionBlockType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
moveFruit: aFruit going: aDirection 
	^aFruit position + aDirection! !

!GhostHouseDoorType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:21'!
moveGhost: aGhost going: aDirection

	^aGhost position + aDirection! !

!GhostHouseDoorType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
movePacman: aPacman going: aDirection
 
	^aPacman position! !

ConstructionBlockType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
moveFruit: aFruit going: aDirection 
 
	^5@10! !

!LeftTransporterType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
moveGhost: aGhost going: aDirection
 
	^aGhost position! !

!LeftTransporterType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:22'!
movePacman: aPacman going: aDirection
 
	^3@10! !

ConstructionBlockType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:25'!
moveFruit: aFruit going: aDirection 

	^aFruit position + aDirection! !

!SpaceType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:24'!
moveGhost: aGhost going: aDirection

	^aGhost position + aDirection! !

!SpaceType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:24'!
movePacman: aPacman going: aDirection

	^ aPacman position + aDirection! !

ConstructionBlockType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:25'!
moveFruit: aFruit going: aDirection 

	^aFruit position! !

!WallType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:25'!
moveGhost: aGhost going: aDirection

	^aGhost position! !

!WallType methodsFor: 'moving' stamp: 'achavez 5/2/2013 19:25'!
movePacman: aPacman going: aDirection

	^ aPacman position! !
